unit fServerForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls,
  uROClient, uROPoweredByRemObjectsButton, uROClientIntf,
  uROJSONMessage, uROIpTCPServer, uROIndyHTTPServer, uROBaseHTTPServer,
  uROServer, uROBinMessage,
  uROHTTPDispatch, uROHTTPFileDispatcher,
  IdBaseComponent, IdIntercept, IdServerInterceptLogBase,
  IdServerInterceptLogEvent, IdComponent, IdServerIOHandler, IdSSL, IdSSLOpenSSL,
  IdContext, IdCustomHTTPServer, IdGlobal, IdServerIOHandlerStack,
  IdIOHandlerStack,
  uROHTTPWebsocketServer, uROIndyTCPServer, uROSessions, uROEventRepository;

type
  //TROIpHTTPServer = class(TROIpHTTPServer_RBK);
  TROIndyHTTPServer = class(TROIndyHTTPWebsocketServer);

  TServerForm = class(TForm)
    RoPoweredByRemObjectsButton1: TRoPoweredByRemObjectsButton;
    ROMessage: TROJSONMessage;
    ROIndyHTTPServer1: TROIndyHTTPServer;
    ROBinMessage1: TROBinMessage;
    ROHTTPFileDispatcher1: TROHTTPFileDispatcher;
    Button2: TButton;
    Button1: TButton;
    ROInMemorySessionManager1: TROInMemorySessionManager;
    ROInMemorySessionManager2: TROInMemorySessionManager;
    ROIndyHTTPServer2: TROIndyHTTPServer;
    ROInMemoryEventRepository1: TROInMemoryEventRepository;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ROInMemorySessionManager1SessionCreated(
      const aSession: TROSession);
    procedure ROIndyHTTPServer1InternalIndyServerConnect(AContext: TIdContext);
    procedure ROInMemorySessionManager1CustomCreateSession(
      const aSessionID: TGUID; var Session: TROSession);
  private
  public
  end;

var
  ServerForm: TServerForm;

implementation

uses
  uROSimpleEventRepository, NewLibrary_Intf, NewService_Impl;

{$R *.dfm}

var
  FSimpleEventRepository: TROSimpleWebsocketEventRepository;
var
  ievent: INewEventSink_Writer;

procedure TServerForm.Button1Click(Sender: TObject);
begin
  ievent := nil;
end;

procedure TServerForm.Button2Click(Sender: TObject);
begin
  if FSimpleEventRepository = nil then
  begin
    FSimpleEventRepository := TROSimpleWebsocketEventRepository.Create;
    FSimpleEventRepository.Message  := Self.ROBinMessage1;
    FSimpleEventRepository.ROServer := Self.ROIndyHTTPServer1;
    (FSimpleEventRepository as IInterface)._AddRef;
  end;

  if ievent = nil then
    ievent := FSimpleEventRepository.GetEventWriter(INewEventSink_Writer) as INewEventSink_Writer;
  ievent.NewMethod(ROBinMessage1.ClientID, 'test');
end;

procedure TServerForm.FormCreate(Sender: TObject);
begin
  ROIndyHTTPServer1.Active := True;
  ROIndyHTTPServer2.Active := True;

  GServerSessionDictionary.Add(ROIndyHTTPServer1.IndyServer, ROInMemorySessionManager1);
  GServerSessionDictionary.Add(ROIndyHTTPServer2.IndyServer, ROInMemorySessionManager2);
end;

procedure TServerForm.ROIndyHTTPServer1InternalIndyServerConnect(
  AContext: TIdContext);
begin
  //
end;

procedure TServerForm.ROInMemorySessionManager1CustomCreateSession(
  const aSessionID: TGUID; var Session: TROSession);
begin
  Session := TROSessionContext.Create(aSessionID);
end;

procedure TServerForm.ROInMemorySessionManager1SessionCreated(
  const aSession: TROSession);
begin
  //
end;

end.
